'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.Request = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = require('lodash/get');

var _get2 = _interopRequireDefault(_get);

var _transform = require('lodash/transform');

var _transform2 = _interopRequireDefault(_transform);

var _events = require('events');

var _toSpeechResponse = require('./toSpeechResponse');

var _getEventName = require('./getEventName');

var _debug = require('debug');

var _debug2 = _interopRequireDefault(_debug);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var log = (0, _debug2.default)('alexa-ability:ability:request');

var Request = exports.Request = function (_EventEmitter) {
    _inherits(Request, _EventEmitter);

    function Request(event) {
        _classCallCheck(this, Request);

        // metadata

        var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(Request).call(this));

        _this.raw = event;
        _this.handler = (0, _getEventName.getEventName)(event);
        _this.sent = false;
        _this.isNew = (0, _get2.default)(event, 'session.new', false);
        _this.isEnding = !!(0, _get2.default)(event, 'request.reason');
        _this.reason = (0, _get2.default)(event, 'request.reason', null);

        // request data
        _this.version = (0, _get2.default)(event, 'version', '1.0');
        _this.user = (0, _get2.default)(event, 'session.user', {});
        _this.session = (0, _get2.default)(event, 'session.attributes', {});
        _this.slots = _this.params = (0, _transform2.default)((0, _get2.default)(event, 'request.intent.slots'), function (obj, slot) {
            obj[slot.name] = slot.value;
        }, {});

        _this._res = {
            outputSpeech: null,
            card: null,
            reprompt: null,
            shouldEndSession: false
        };
        return _this;
    }

    _createClass(Request, [{
        key: 'say',
        value: function say(type, value) {
            this._res.outputSpeech = (0, _toSpeechResponse.toSpeechResponse)(type, value);
            return this;
        }
    }, {
        key: 'show',
        value: function show(card, text) {
            if (typeof card === 'string') {
                log('showing Simple card');
                this._res.card = {
                    type: 'Simple',
                    title: card,
                    content: text
                };
            } else {
                log('showing Standard card type');
                // TODO validation?
                this._res.card = _extends({
                    type: 'Standard'
                }, card);
            }
            return this;
        }
    }, {
        key: 'linkAccount',
        value: function linkAccount() {
            this._res.card = {
                type: 'LinkAccount'
            };
            return this;
        }
    }, {
        key: 'reprompt',
        value: function reprompt(type, value) {
            this._res.reprompt = {
                outputSpeech: (0, _toSpeechResponse.toSpeechResponse)(type, value)
            };
            return this;
        }
    }, {
        key: 'end',
        value: function end() {
            this._res.shouldEndSession = true;
            return this.send();
        }
    }, {
        key: 'send',
        value: function send() {
            this.sent = true;
            this.emit('finished', this);
            // fine to return undefined
        }
    }, {
        key: 'fail',
        value: function fail(err) {
            this.sent = true;
            this.emit('failed', err, this);
        }
    }, {
        key: 'toJSON',
        value: function toJSON() {
            var version = this.version;
            var session = this.session;
            var response = this._res;


            return {
                version: version,
                response: response,
                sessionAttributes: session
            };
        }
    }]);

    return Request;
}(_events.EventEmitter);

// Setup some simple aliases
// Eventually I'd like to use a decorator for this but the spec isn't totally ready


Request.prototype.ask = Request.prototype.send;
Request.prototype.tell = Request.prototype.end;