'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.getEventName = getEventName;

var _get = require('lodash/get');

var _get2 = _interopRequireDefault(_get);

var _debug = require('debug');

var _debug2 = _interopRequireDefault(_debug);

var _standardEvents = require('./standardEvents');

var e = _interopRequireWildcard(_standardEvents);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var log = (0, _debug2.default)('alexa-ability:getEventName');

function getEventName(event) {
    var type = (0, _get2.default)(event, 'request.type');
    log('getting event name for request type: ' + type);

    switch (type) {
        case 'LaunchRequest':
            return e.launch;

        case 'IntentRequest':
            return (0, _get2.default)(event, 'request.intent.name');

        case 'SessionEndedRequest':
            return e.end;

        default:
            log('weird event %o', event);
            return null;
    }
}