"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.handleEvent = handleEvent;

/**
 * A simple middleware function that wraps a handler
 * to only respond to the give event
 * @param {String} event
 * @param {Function} handler
 */
function handleEvent(event, handler) {
    var isMatch = function isMatch(req) {
        return req.handler === event;
    };
    var isErrorHandler = handler.length >= 3;

    var fn = isErrorHandler ? function (err, req, next) {
        return isMatch(req) ? handler(err, req, next) : next();
    } : function (req, next) {
        return isMatch(req) ? handler(req, next) : next();
    };

    fn.displayName = handler.name; // for debug statements
    return fn;
}