"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.resolve = resolve;

/**
 * Simple try catcher around a node-style async function
 *
 * @param {Function} fn
 * @param {Function} done - the node-style callback
 * @param {...*} args - any arguments
 */
function resolve(fn, done) {
    try {
        for (var _len = arguments.length, args = Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
            args[_key - 2] = arguments[_key];
        }

        fn.apply(undefined, args.concat([done]));
    } catch (e) {
        done(e);
    }
}