'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.toSpeechResponse = toSpeechResponse;

/**
 * Takes content and an optional type arguments
 * and returns a valid outputSpeech object
 *
 * Examples:
 *   toSpeechResponse('hello world')
 *   toSpeechResponse('text', 'hello world')
 *   toSpeechResponse('ssml', '<speak/>')
 *
 * @param {String=} type - 'ssml' or 'text'
 * @param {SSML|String} content
 * @return {Object}
 */
function toSpeechResponse(_type, _content) {
  var type = _content === undefined ? 'text' : _type;
  var content = _content === undefined ? _type : _content;

  return type === 'ssml' ? { type: 'SSML', ssml: content } : { type: 'PlainText', text: content };
}